//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#ifndef __bbcreaImageIOReadImages_h_INCLUDED__
#define __bbcreaImageIOReadImages_h_INCLUDED__

#include "bbcreaImageIO_EXPORT.h"
#include "bbtkAtomicBlackBox.h"
#include "iostream"
#include <vtkImageData.h>

namespace bbcreaImageIO
{


typedef std::map<std::string, std::string> MapInfoDicom;
typedef std::vector< MapInfoDicom > VectorMapInfoDicom;

class bbcreaImageIO_EXPORT ReadImages
 : 
   public bbtk::AtomicBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(ReadImages,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
  BBTK_DECLARE_INPUT(Active,bool);
  BBTK_DECLARE_INPUT(DicomTags,std::vector<std::string>);
  BBTK_DECLARE_INPUT(LstNameImages,std::vector<std::string>);
  BBTK_DECLARE_OUTPUT(Out,vtkImageData*);
  BBTK_DECLARE_OUTPUT(OutImages,std::vector<vtkImageData*>);
  BBTK_DECLARE_OUTPUT(DicomInfo,VectorMapInfoDicom);
  BBTK_PROCESS(Process);
  void Process();
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(ReadImages,bbtk::AtomicBlackBox);
  BBTK_NAME("ReadImages");
  BBTK_AUTHOR("InfoDev");
  BBTK_DESCRIPTION("No Description.");
  BBTK_CATEGORY("empty");

  BBTK_INPUT(ReadImages,Active,"(default true)  Active true/false",bool,"");
  BBTK_INPUT(ReadImages,DicomTags,"Dicom Tags (vector of Dicom tags ex: D0028_0030  D0020_0037)",std::vector<std::string>,"");
  BBTK_INPUT(ReadImages,LstNameImages,"List path to images",std::vector<std::string>,"");

  BBTK_OUTPUT(ReadImages,Out,"Output Image",vtkImageData*,"");
  BBTK_OUTPUT(ReadImages,OutImages,"List of Output Image",std::vector<vtkImageData*>,"");
  BBTK_OUTPUT(ReadImages,DicomInfo,"vector of maps of Dicom tags",VectorMapInfoDicom,"");
  
BBTK_END_DESCRIBE_BLACK_BOX(ReadImages);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
}
// EO namespace bbcreaImageIO

#endif // __bbcreaImageIOReadImages_h_INCLUDED__

